CREATE OR REPLACE PROCEDURE ATUALIZA_SALDO_SOC(
  P_CDEMPRESA IN EMPRESA.CDEMPRESA%TYPE,
  P_CDCONTINI IN CONTCTBL.CDCONTCTBL%TYPE,
  P_CDCONTFIN IN CONTCTBL.CDCONTCTBL%TYPE,
  P_DATAINIC  IN CONTOPECTBL.DTFINALANC%TYPE,
  P_DATAFIM IN CONTOPECTBL.DTFINALANC%TYPE)
IS

  V_CDCONTINI   CONTCTBL.CDCONTCTBL%TYPE;
  V_CDCONTFIM   CONTCTBL.CDCONTCTBL%TYPE;
  V_DTFINACONT  DATE;
  DATA_SALDO    DATE;
  V_CONTSALDO   CHAR;
  V_VERSAO      VARCHAR2(1);
  V_VRSALDO     NUMBER;
  V_CONTA       CONTCTBL.CDCONTCTBL%TYPE;
  V_TESTELOOP   CHAR;
  MENOR_DATA    DATE;
  V_COUNT       NUMBER;
  V_DATATEMP    DATE;
  V_DARCOMMIT   NUMBER;
  V_CONTCOMMIT NUMBER;
  V_VRSALDOSOCIET NUMBER;

BEGIN
    /* ROTINA RESPONSVEL POR RECALCULAR O SALDO SOCIETRIO. O FUNCIONAMENTO E
       CLCULO FUNCIONAM DA MESMA FORMA. FOI PRECISO CRIAR OUTRAS TABELAS
       DEVIDO AOS ENCERRAMENTOS DOS SALDOS, DA FORMA SOCIETRIA, SEREM EM DATAS
       DIFERENTES DAS DATAS DOS ENCERRAMENTOS FISCAIS */
       
    V_DARCOMMIT := 50;
    V_CONTCOMMIT := 1;
    SELECT MAX(SUBSTR(BANNER,7,1))
      INTO V_VERSAO
      FROM V$VERSION
     WHERE BANNER LIKE 'Orac%';

    IF V_VERSAO <> '9' THEN
       COMMIT;
       SET TRANSACTION USE ROLLBACK SEGMENT RBS_TECNISA;
    END IF;

    V_COUNT := 0;
    BEGIN
       SELECT COUNT(*)
         INTO V_COUNT
         FROM CONTCTBL
        WHERE CDCONTCTBL = P_CDCONTFIN
          AND IDTIPOCONT = 'A';
    EXCEPTION
       WHEN NO_DATA_FOUND THEN
          V_COUNT := 0;
    END;

    IF V_COUNT <> 0 THEN
       SELECT MAX(CDCONTCTBL)
         INTO V_CDCONTFIM
         FROM CONTCTBL
        WHERE CDCONTCTBL BETWEEN SUBSTR(P_CDCONTFIN, 1, 1) AND P_CDCONTFIN
          AND (IDCONTCCUS <> 'R');
    ELSE
       SELECT MAX(CDCONTCTBL)
         INTO V_CDCONTFIM
         FROM CONTCTBL
        WHERE CDCONTCTBL BETWEEN SUBSTR(P_CDCONTFIN, 1, 1) AND (P_CDCONTFIN || 'zzzzzzzzzzzzzzzzzzz')
          AND (IDCONTCCUS <> 'R');
    END IF;

    SELECT MIN(CDCONTCTBL)
      INTO V_CDCONTINI
      FROM CONTCTBL
     WHERE (INSTR(P_CDCONTINI,RTRIM(CONTCTBL.CDCONTCTBL)) = 1)
       AND (IDCONTCCUS <> 'R');

    DELETE FROM SALDOSOCIET
     WHERE (SALDOSOCIET.CDEMPRESA  = P_CDEMPRESA)
       AND (SALDOSOCIET.DTSALDOSOCIET >= P_DATAINIC)
       AND (SALDOSOCIET.CDCONTCTBL IN (SELECT CDCONTCTBL
                                         FROM CONTCTBL
                                        WHERE (CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM)
                                          AND (IDCONTCCUS <> 'R')));
    DELETE FROM SALDOTRANSFS
     WHERE (SALDOTRANSFS.CDEMPRESA     = P_CDEMPRESA)
       AND (SALDOTRANSFS.DTSALDOTRANSFS >= P_DATAINIC)
       AND (SALDOTRANSFS.CDCONTCTBL IN (SELECT CDCONTCTBL
                                          FROM CONTCTBL
                                         WHERE (CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM)
                                           AND (IDCONTCCUS <> 'R')));
    V_CONTCOMMIT := V_CONTCOMMIT +1;
    V_DTFINACONT := P_DATAFIM;
    FOR MES IN
       (SELECT DISTINCT DTMES PRIMDIA, LAST_DAY(DTDATA) ULTIMODIA
          FROM DATA
         WHERE DTDATA BETWEEN P_DATAINIC AND V_DTFINACONT
         ORDER BY 1) LOOP

       /*ATUALIZA SALDO ANTERIOR */
       FOR SALDANTSOCIET IN
           (SELECT SALDOSOCIET.CDCONTCTBL, SALDOSOCIET.DTSALDOSOCIET, SALDOSOCIET.VRSALDOSOCIET
              FROM SALDOSOCIET, CONTCTBL
             WHERE (SALDOSOCIET.CDEMPRESA  = P_CDEMPRESA)
               AND (SALDOSOCIET.CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM)
               AND (SALDOSOCIET.CDCONTCTBL = CONTCTBL.CDCONTCTBL)
               AND (CONTCTBL.IDCONTCCUS <> 'R')
               AND (SALDOSOCIET.DTSALDOSOCIET = (SELECT MAX(S.DTSALDOSOCIET)
                                                   FROM SALDOSOCIET S
                                                  WHERE S.CDCONTCTBL = SALDOSOCIET.CDCONTCTBL
                                                    AND S.CDEMPRESA  = P_CDEMPRESA
                                                    AND S.DTSALDOSOCIET < MES.PRIMDIA))) LOOP

           DATA_SALDO := SALDANTSOCIET.DTSALDOSOCIET;
           DATA_SALDO := LAST_DAY(DATA_SALDO);

           WHILE (DATA_SALDO <= MES.ULTIMODIA) LOOP
              INSERT INTO SALDOSOCIET
                 (CDEMPRESA, CDCONTCTBL, DTSALDOSOCIET, VRSALDOSOCIET)
                 (SELECT P_CDEMPRESA, CDCONTCTBL, DATA_SALDO, 0
                    FROM CONTCTBL C
                   WHERE NOT EXISTS (SELECT 1
                                       FROM SALDOSOCIET S
                                      WHERE C.CDCONTCTBL = S.CDCONTCTBL
                                        AND CDEMPRESA = P_CDEMPRESA
                                        AND DTSALDOSOCIET = DATA_SALDO)
                     AND (INSTR(SALDANTSOCIET.CDCONTCTBL,RTRIM(C.CDCONTCTBL)) = 1));
                 V_CONTCOMMIT := V_CONTCOMMIT +1 ;
                 IF V_CONTCOMMIT = V_DARCOMMIT THEN
                    V_CONTCOMMIT := 1;
                    COMMIT;
                 END IF;
                 DATA_SALDO := ADD_MONTHS(DATA_SALDO,1);
            END LOOP;


           UPDATE SALDOSOCIET
              SET VRSALDOSOCIET = SALDANTSOCIET.VRSALDOSOCIET
            WHERE (SALDOSOCIET.CDEMPRESA  = P_CDEMPRESA)
              AND (SALDOSOCIET.DTSALDOSOCIET >= MES.PRIMDIA)
              AND (SALDOSOCIET.CDCONTCTBL  = SALDANTSOCIET.CDCONTCTBL);
           V_CONTCOMMIT := V_CONTCOMMIT + 1;
           IF V_CONTCOMMIT = V_DARCOMMIT THEN
              V_CONTCOMMIT := 1;
              COMMIT;
           END IF;
       END LOOP;

       /* Atualiza saldo Contbil */
       FOR ATUALIZASOCIET IN
           (SELECT LANCCONT.CDCONTCTBL, TRUNC(MIN(DTLANCCONT)) AS MENOR_DATA
              FROM LANCCONT, CONTCTBL
             WHERE (LANCCONT.CDEMPRESA   = P_CDEMPRESA)
               AND (LANCCONT.DTLANCCONT BETWEEN MES.PRIMDIA AND MES.ULTIMODIA)
               AND (LANCCONT.CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM)
               AND (LANCCONT.CDCONTCTBL = CONTCTBL.CDCONTCTBL)
               AND (CONTCTBL.IDCONTCCUS <> 'R')
               AND (LANCCONT.IDLANCINTE <> 'F')
        GROUP BY LANCCONT.CDCONTCTBL) LOOP

          DATA_SALDO := ATUALIZASOCIET.MENOR_DATA;
          DATA_SALDO := LAST_DAY(DATA_SALDO);

          V_CONTSALDO := 0;
          BEGIN
             SELECT COUNT(*)
               INTO V_CONTSALDO
               FROM SALDOSOCIET
              WHERE (SALDOSOCIET.CDEMPRESA  = P_CDEMPRESA)
                AND (SALDOSOCIET.CDCONTCTBL = ATUALIZASOCIET.CDCONTCTBL)
                AND (SALDOSOCIET.DTSALDOSOCIET = DATA_SALDO);
          EXCEPTION
             WHEN NO_DATA_FOUND THEN
                V_CONTSALDO := 0;
          END;
          IF (V_CONTSALDO = 0) THEN
             WHILE (DATA_SALDO <= MES.ULTIMODIA) LOOP
                INSERT INTO SALDOSOCIET
                   (CDEMPRESA, CDCONTCTBL, DTSALDOSOCIET, VRSALDOSOCIET)
                (SELECT P_CDEMPRESA, CDCONTCTBL, DATA_SALDO, 0
                   FROM CONTCTBL C
                  WHERE NOT EXISTS (SELECT 1
                                      FROM SALDOSOCIET S
                                     WHERE C.CDCONTCTBL = S.CDCONTCTBL
                                       AND CDEMPRESA = P_CDEMPRESA
                                       AND DTSALDOSOCIET = DATA_SALDO)
                    AND (INSTR(ATUALIZASOCIET.CDCONTCTBL,RTRIM(C.CDCONTCTBL)) = 1));
                V_CONTCOMMIT := V_CONTCOMMIT +1 ;
                IF V_CONTCOMMIT = V_DARCOMMIT THEN
                   V_CONTCOMMIT := 1;
                   COMMIT;
                END IF;
                DATA_SALDO := ADD_MONTHS(DATA_SALDO,1);
             END LOOP;
          END IF;
          DATA_SALDO := ATUALIZASOCIET.MENOR_DATA;
          DATA_SALDO := LAST_DAY(DATA_SALDO);

          WHILE (DATA_SALDO <= MES.ULTIMODIA) LOOP
             FOR SOMACONTA IN
                (SELECT CDCONTCTBL, SUM(ROUND(LANCCONT.VRLANCAMENT,2)) AS VALORSALDO
                   FROM LANCCONT
                  WHERE (LANCCONT.DTLANCCONT BETWEEN ATUALIZASOCIET.MENOR_DATA AND DATA_SALDO)
                    AND (LANCCONT.CDCONTCTBL = ATUALIZASOCIET.CDCONTCTBL)
                    AND (LANCCONT.CDEMPRESA  = P_CDEMPRESA)
                    AND (LANCCONT.IDLANCINTE <> 'F')
                  GROUP BY LANCCONT.CDCONTCTBL) LOOP

                UPDATE SALDOSOCIET
                   SET VRSALDOSOCIET = SALDOSOCIET.VRSALDOSOCIET + SOMACONTA.VALORSALDO
                 WHERE (SALDOSOCIET.CDEMPRESA  = P_CDEMPRESA)
                   AND (SALDOSOCIET.DTSALDOSOCIET = DATA_SALDO)
                   AND (INSTR(SOMACONTA.CDCONTCTBL,RTRIM(SALDOSOCIET.CDCONTCTBL)) = 1);
                V_CONTCOMMIT := V_CONTCOMMIT + 1;
                IF V_CONTCOMMIT = V_DARCOMMIT THEN
                   V_CONTCOMMIT := 1;
                   COMMIT;
                END IF;
             END LOOP;
             DATA_SALDO := ADD_MONTHS(DATA_SALDO, 1);
          END LOOP;
       END LOOP;

       /* ATUALIZA SALDOS ANTES DOS ENCERRAMENTOS */
       FOR SALDO IN(
          SELECT L.CDCONTCTBL, LAST_DAY(L.DTLANCCONT) DTLANCCONT
            FROM LANCCONT L, CONTCTBL C
           WHERE L.CDEMPRESA  = P_CDEMPRESA
             AND L.IDLANCINTE = 'S'
             AND L.DTLANCCONT  BETWEEN MES.PRIMDIA AND MES.ULTIMODIA
             AND (L.CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM)
             AND L.CDCONTCTBL = C.CDCONTCTBL
             AND C.IDCONTCCUS <> 'R'
          GROUP BY L.CDCONTCTBL, LAST_DAY(L.DTLANCCONT)
          ORDER BY 2, 1) LOOP

          BEGIN
             SELECT SUM(NVL(VRLANCAMENT, 0)) AS VRLANCAMENT
               INTO V_VRSALDO
               FROM LANCCONT
              WHERE CDEMPRESA  = P_CDEMPRESA
                AND IDLANCINTE NOT IN ('S', 'F')
                AND CDCONTCTBL = SALDO.CDCONTCTBL
                AND DTLANCCONT BETWEEN MES.PRIMDIA AND MES.ULTIMODIA;
          EXCEPTION
             WHEN NO_DATA_FOUND THEN
                V_VRSALDO := 0;
          END;

          BEGIN
             SELECT NVL(SA.VRSALDOSOCIET, 0)
               INTO V_VRSALDOSOCIET
               FROM SALDOSOCIET SA
              WHERE SA.CDEMPRESA  = P_CDEMPRESA
                AND SA.CDCONTCTBL = SALDO.CDCONTCTBL
                AND SA.DTSALDOSOCIET = ADD_MONTHS(SALDO.DTLANCCONT,-1);
          EXCEPTION
             WHEN NO_DATA_FOUND THEN
                V_VRSALDOSOCIET := 0;
          END;

          V_VRSALDO := NVL(V_VRSALDO, 0) + NVL(V_VRSALDOSOCIET, 0);

          IF V_VRSALDO <> 0 THEN
             INSERT INTO SALDOTRANSFS
               (CDEMPRESA, CDCONTCTBL, DTSALDOTRANSFS, VRSALDOTRANSFS)
             VALUES
               (P_CDEMPRESA, SALDO.CDCONTCTBL, SALDO.DTLANCCONT, NVL(V_VRSALDO, 0));
          END IF;
       END LOOP;

       FOR ATUALIZASOCIET IN
          (SELECT DISTINCT LANCCONT.CDCONTCTBL, LAST_DAY(DTLANCCONT) AS DTLANCCONT
             FROM LANCCONT, CONTCTBL
            WHERE (LANCCONT.CDEMPRESA   = P_CDEMPRESA)
              AND (LANCCONT.DTLANCCONT >= MES.PRIMDIA)
              AND (LANCCONT.CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM)
              AND (LANCCONT.CDCONTCTBL = CONTCTBL.CDCONTCTBL)
              AND (CONTCTBL.IDCONTCCUS <> 'R')
              AND (LANCCONT.IDLANCINTE = 'S')
            ORDER BY 2, 1) LOOP

          SELECT NVL(SUM(VRLANCAMENT), 0)
            INTO V_VRSALDO
            FROM LANCCONT
           WHERE TO_CHAR(DTLANCCONT, 'MM/YYYY') = TO_CHAR(ATUALIZASOCIET.DTLANCCONT, 'MM/YYYY')
             AND CDEMPRESA  = P_CDEMPRESA
             AND CDCONTCTBL = ATUALIZASOCIET.CDCONTCTBL
             AND IDLANCINTE NOT IN ('S', 'F');

          SELECT TRUNC(MIN(DTLANCCONT))
            INTO MENOR_DATA
            FROM LANCCONT
           WHERE (LANCCONT.CDEMPRESA   = P_CDEMPRESA)
             AND (LANCCONT.DTLANCCONT >= MES.PRIMDIA)
             AND (LANCCONT.CDCONTCTBL = ATUALIZASOCIET.CDCONTCTBL);

          DATA_SALDO := LAST_DAY(MENOR_DATA);

          WHILE (DATA_SALDO <= MES.ULTIMODIA) LOOP
             INSERT INTO SALDOTRANSFS
                (CDEMPRESA, CDCONTCTBL, DTSALDOTRANSFS, VRSALDOTRANSFS)
                (SELECT P_CDEMPRESA, CDCONTCTBL, DATA_SALDO, V_VRSALDO
                   FROM CONTCTBL
                  WHERE (CDCONTCTBL NOT IN (SELECT DISTINCT CDCONTCTBL
                                              FROM SALDOTRANSFS
                                             WHERE ((CDEMPRESA    = P_CDEMPRESA)
                                               AND (DTSALDOTRANSFS = DATA_SALDO))))
                    AND (INSTR(ATUALIZASOCIET.CDCONTCTBL, RTRIM(CONTCTBL.CDCONTCTBL)) = 1));

             V_CONTCOMMIT := V_CONTCOMMIT +1 ;
             IF V_CONTCOMMIT = V_DARCOMMIT THEN
                V_CONTCOMMIT := 1;
                COMMIT;
             END IF;
             DATA_SALDO := ADD_MONTHS(DATA_SALDO,1);
          END LOOP;
       END LOOP;

       /* ATUALIZA OS VALORES DE TRANSFERNCIA PARA CONTAS CONTBEIS SINTTICAS */
       /* TRAZ OS VALORES DAS CONTAS CONTBEIS E AS PRPRIAS CONTAS A PARTIR DA DATA INICIAL */
       FOR SALDO_SINTETICOSOC IN
          (SELECT VRSALDOTRANSFS, DTSALDOTRANSFS, S.CDCONTCTBL
             FROM SALDOTRANSFS S, CONTCTBL C
            WHERE S.CDEMPRESA = P_CDEMPRESA
              AND S.DTSALDOTRANSFS >= MES.PRIMDIA
              AND S.CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM
              AND S.CDCONTCTBL = C.CDCONTCTBL
              and C.IDCONTCCUS <> 'R'
              AND C.IDTIPOCONT = 'S'
            ORDER BY 2, 3) LOOP

          DATA_SALDO := LAST_DAY(SALDO_SINTETICOSOC.DTSALDOTRANSFS);

          WHILE (DATA_SALDO <= MES.ULTIMODIA) LOOP
          /*TRAZ OS SALDOS DOS MESES ANTERIORES S TRANSFERNCIAS */
             BEGIN
                SELECT NVL(VRSALDOSOCIET, 0)
                  INTO V_VRSALDOSOCIET
                  FROM SALDOSOCIET S
                 WHERE S.CDEMPRESA  = P_CDEMPRESA
                   AND S.CDCONTCTBL = SALDO_SINTETICOSOC.CDCONTCTBL
                   AND S.DTSALDOSOCIET = ADD_MONTHS(SALDO_SINTETICOSOC.DTSALDOTRANSFS, -1);
              EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                    V_VRSALDOSOCIET := 0;
              END;

              BEGIN
                SELECT NVL(SUM(VRLANCAMENT), 0)
                  INTO V_VRSALDO
                  FROM LANCCONT L, CONTCTBL C
                 WHERE L.CDEMPRESA  = P_CDEMPRESA
                   AND L.CDCONTCTBL LIKE SALDO_SINTETICOSOC.CDCONTCTBL || '%'
                   AND TO_CHAR(L.DTLANCCONT, 'MM/YYYY') = TO_CHAR(SALDO_SINTETICOSOC.DTSALDOTRANSFS, 'MM/YYYY')
                   AND L.CDCONTCTBL = C.CDCONTCTBL
                   AND L.IDLANCINTE NOT IN ('S', 'F')
                   AND C.IDCONTCCUS <> 'R'
                   AND C.IDTIPOCONT = 'A';
              EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                    V_VRSALDO := 0;
              END;

           /* ATUALIZA O SALDO DA CONTA SOMANDO O VALOR ANTERIOR DA SALDOSOCIET MAIS
              OS VALORES DOS LANAMENTOS DO MS, ESTES VALORES J ESTO GRAVADOS NA TABELA */
             UPDATE SALDOTRANSFS
                SET VRSALDOTRANSFS = V_VRSALDOSOCIET + V_VRSALDO
              WHERE DTSALDOTRANSFS = DATA_SALDO
                AND CDEMPRESA     = P_CDEMPRESA
                AND CDCONTCTBL    = SALDO_SINTETICOSOC.CDCONTCTBL;
             V_CONTCOMMIT := V_CONTCOMMIT +1 ;
             IF V_CONTCOMMIT = V_DARCOMMIT THEN
                V_CONTCOMMIT := 1;
                COMMIT;
             END IF;
             DATA_SALDO := ADD_MONTHS(DATA_SALDO, 1);
          END LOOP;
       END LOOP;
    END LOOP;
    COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_SALDO_SOC','5.70.000'); END;
/
