/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GRSV                                                     */
/* Tabela : GRUPSERV                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_GRSV'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_GRSV
GO

CREATE TRIGGER DTULTATU_GRSV
ON GRUPSERV
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'GRUPSERV', 'CDGRUPSERV=' + CDGRUPSERV + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE GRUPSERV
      SET DTULTATUGRSV = GETDATE()
      FROM INSERTED
      WHERE
       ISNULL(GRUPSERV.CDGRUPSERV,0) = ISNULL(INSERTED.CDGRUPSERV,0);
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_GRSV','4.05.111';
GO

