IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CALCULA_CUSTO_OP_CONS'  AND
	        TYPE = 'P' 			        AND
	        U.UID = O.UID             		        AND
	        U.NAME = USER)

DROP PROCEDURE CALCULA_CUSTO_OP_CONS
GO


CREATE PROCEDURE CALCULA_CUSTO_OP_CONS
        @P_CDFILIAL     VARCHAR (4),
        @P_NRORDPROD    VARCHAR (10),
        @P_NRSUBORDPROD VARCHAR (1)
AS
   DECLARE @V_SEQUCUSTO                VARCHAR(10);
   DECLARE @V_TIPOCUSTO                VARCHAR(02);
   DECLARE @V_NMTPCUSTO                VARCHAR(60);
   DECLARE @V_CDCUSTOINDI              VARCHAR(03);
   DECLARE @V_CDETAPAPROD              VARCHAR(10);
   DECLARE @V_VRFATOCONVES             DOUBLE PRECISION;
   DECLARE @V_QTPERDAOP                DOUBLE PRECISION;
   DECLARE @V_QTPRODUCAO               DOUBLE PRECISION;
   DECLARE @V_QUANTIDADE               DOUBLE PRECISION;
   DECLARE @V_IDTPCALCCUSPROD          VARCHAR(1);

   DECLARE @C_PRODACABADO_CDPRODUTO    VARCHAR(10);
   DECLARE @C_PRODACABADO_CDPROCFABRIC VARCHAR(10);
   DECLARE @C_PRODACABADO_QTPRACABADO  DOUBLE PRECISION;
   DECLARE @C_PRODACABADO_QTAPRODPREOP DOUBLE PRECISION;
   DECLARE @C_PRODACABADO_CDFILIAL     VARCHAR(4);
   DECLARE @C_PRODACABADO_NRLOTEESTQ   VARCHAR(20);
   DECLARE @C_PRODACABADO_NRSUBLOTE    VARCHAR(4);

   DECLARE @C_INSUMOS_QTDEINSUMO       DOUBLE PRECISION;
   DECLARE @C_INSUMOS_CDPRODUTO        VARCHAR(10);
   DECLARE @C_INSUMOS_CDPRODINSUMO     VARCHAR(10);
   DECLARE @C_INSUMOS_CDETAPAPROD      VARCHAR(10);

   DECLARE @C_CUSTOETAPA_VRCUSTO       DOUBLE PRECISION;
   DECLARE @C_CUSTOETAPA_QTDE_INSUMO   DOUBLE PRECISION;
   DECLARE @C_CUSTOETAPA_NMPRODUTO     VARCHAR(50);
   DECLARE @C_CUSTOETAPA_CDCENTCUST    VARCHAR(4);

   DECLARE @V_IDSITORDPROD             VARCHAR(1);
BEGIN
   SELECT @V_IDSITORDPROD = MAX(IDSITORDPROD)
     FROM ORDPRODUCAO
    WHERE CDFILIAL     = @P_CDFILIAL      AND
          NRORDPROD    = @P_NRORDPROD     AND
          NRSUBORDPROD = @P_NRSUBORDPROD;

   IF (@V_IDSITORDPROD <> '3') BEGIN

      DELETE
      FROM APRCUSTOP
      WHERE CDFILIAL     = @P_CDFILIAL      AND
            NRORDPROD    = @P_NRORDPROD     AND
            NRSUBORDPROD = @P_NRSUBORDPROD;

      SET @V_SEQUCUSTO = 0;


      SELECT @V_TIPOCUSTO = MAX(NRTPCUSTOOP), @V_IDTPCALCCUSPROD = MAX(IDTPCALCCUSPROD)
      FROM
         PARAMAN
      WHERE
         CDFILIAL = @P_CDFILIAL;

      SELECT @V_CDCUSTOINDI = MAX(CDCUSTOINDI)
        FROM CUSTOINDI
       WHERE CDFUNCUSTO = '001';

      IF @V_CDCUSTOINDI IS NOT NULL BEGIN


         DECLARE C_PRODACABADO CURSOR FOR
                               SELECT O.CDFILIAL, SUM(O.QTAPRODPREOP)AS QTAPRODPREOP,
                                       O.CDPRODUTO, O.CDPROCFABRIC ,
                                       MAX(O.NRLOTEESTQ)AS NRLOTEESTQ, MAX(O.NRSUBLOTE)AS NRSUBLOTE,
                                       P.QTPRACABADO
                                FROM ORDPRODUCAO O LEFT JOIN PRODACABADO P ON
                                                                  (O.NRORDPRODCON = P.NRORDPROD    AND
                                                                   O.NRSUBOPCON   = P.NRSUBORDPROD AND
                                                                   O.CDFILIAL     = P.CDFILIAL     AND
                                                                   O.CDPRODUTO    = P.CDPRODUTO)
                                WHERE
                                   O.NRORDPRODCON = @P_NRORDPROD      AND
                                   O.NRSUBOPCON   = @P_NRSUBORDPROD   AND
                                   O.CDFILIAL     = @P_CDFILIAL
                                GROUP BY
                                   O.CDFILIAL ,O.CDPRODUTO, O.CDPROCFABRIC, P.QTPRACABADO
                                ORDER BY
                                   O.CDPRODUTO;

         OPEN C_PRODACABADO;
         FETCH NEXT FROM C_PRODACABADO INTO  @C_PRODACABADO_CDFILIAL,
                                             @C_PRODACABADO_QTAPRODPREOP,
                                             @C_PRODACABADO_CDPRODUTO,
                                             @C_PRODACABADO_CDPROCFABRIC,
                                             @C_PRODACABADO_NRLOTEESTQ,
                                             @C_PRODACABADO_NRSUBLOTE,
                                             @C_PRODACABADO_QTPRACABADO;

         WHILE (@@FETCH_STATUS = 0) BEGIN


            DECLARE C_INSUMOS CURSOR FOR
                                      SELECT
                                         SUM( TEKNISA.QTPREVI_MATPRIMA(@C_PRODACABADO_CDFILIAL, @C_PRODACABADO_CDPRODUTO, @C_PRODACABADO_CDPROCFABRIC,
                                         CDETAPAPROD, CDPRODINSUMO, case @V_IDTPCALCCUSPROD when '2' then @C_PRODACABADO_QTAPRODPREOP else ISNULL(@C_PRODACABADO_QTPRACABADO, @C_PRODACABADO_QTAPRODPREOP) end , 'S')) AS QTDEINSUMO,
                                         CDPRODUTO, CDPRODINSUMO, CDETAPAPROD
                                      FROM  INSUMETAPA
                                      WHERE
                                         CDFILIAL      = @C_PRODACABADO_CDFILIAL     AND
                                         CDPRODUTO     = @C_PRODACABADO_CDPRODUTO    AND
                                         CDPROCFABRIC  = @C_PRODACABADO_CDPROCFABRIC
                                      GROUP BY
                                         CDPRODUTO, CDPRODINSUMO, CDETAPAPROD
                                      ORDER BY
                                         CDPRODINSUMO;


            OPEN C_INSUMOS;
            FETCH NEXT FROM C_INSUMOS INTO   @C_INSUMOS_QTDEINSUMO,
                                             @C_INSUMOS_CDPRODUTO,
                                             @C_INSUMOS_CDPRODINSUMO,
                                             @C_INSUMOS_CDETAPAPROD;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               DECLARE C_CUSTOETAPA CURSOR FOR
                  SELECT VRCUSTO, QTDE_INSUMO, NMPRODUTO, CDCENTCUST FROM(
                     SELECT
                        CASE  ISNULL (@V_IDTPCALCCUSPROD, '1') WHEN '1' THEN (
                                                                           SELECT SUM( CASE IDTPRETEST WHEN 'R' THEN L.QTRETLIQPROD ELSE L.QTRETLIQPROD*(-1) END)*
                                                                                  TEKNISA.CUSTO_PRODUTO_LCEST(@P_CDFILIAL, I.CDPRODUTO, @V_TIPOCUSTO,
                                                                                                      GETDATE(), GETDATE(), L.CDALMOXARIFE, L.CDLOCALESTOQ,
                                                                                                      L.NRLOTEESTQ, L.NRSUBLOTE) / SUM(  CASE IDTPRETEST WHEN 'R' THEN L.QTRETLIQPROD ELSE (L.QTRETLIQPROD*(-1))END)
                                                                           FROM
                                                                              LOTITRETIEST L
                                                                           WHERE
                                                                               I.CDFILIAL       = L.CDFILIAL     AND
                                                                               I.NRRETEST       = L.NRRETEST     AND
                                                                               I.NRSEQRETPROD   = L.NRSEQRETPROD AND
                                                                               I.CDPRODUTO      = L.CDPRODUTO
                                                                           GROUP BY L.CDALMOXARIFE, L.CDLOCALESTOQ, L.NRLOTEESTQ, L.NRSUBLOTE
                                                                          )
                                                                        ELSE ROUND( TEKNISA.CUSTO_PRODUTO(@P_CDFILIAL, I.CDPRODUTO, @V_TIPOCUSTO, GETDATE(), GETDATE()),15) END VRCUSTO,
                        CASE  ISNULL(@V_IDTPCALCCUSPROD, '1') WHEN '2' THEN @C_INSUMOS_QTDEINSUMO ELSE
                                                                    (
                                                                      SELECT SUM( CASE IDTPRETEST WHEN 'R' THEN L.QTRETLIQPROD ELSE (L.QTRETLIQPROD*(-1))END) / SUM(I.QTPRERETPROD) * @C_INSUMOS_QTDEINSUMO
                                                                      FROM
                                                                         LOTITRETIEST L
                                                                      WHERE
                                                                          I.CDFILIAL       = L.CDFILIAL     AND
                                                                          I.NRRETEST       = L.NRRETEST     AND
                                                                          I.NRSEQRETPROD   = L.NRSEQRETPROD AND
                                                                          I.CDPRODUTO      = L.CDPRODUTO
                                                                    )END  AS QTDE_INSUMO,
                          P.NMPRODUTO, R.CDCENTCUST
                        FROM
                           RETIRADAESTO R , ITEMRETIEST I, PRODUTO P
                        WHERE
                           R.CDFILIAL      = @P_CDFILIAL                AND
                           R.NRORDPROD     = @P_NRORDPROD               AND
                           R.NRSUBORDPROD  = @P_NRSUBORDPROD            AND
                           I.CDPRODUTO     = @C_INSUMOS_CDPRODINSUMO    AND
                           R.CDFILIAL      = I.CDFILIAL      AND
                           R.NRRETEST      = I.NRRETEST      AND
                           I.CDPRODUTO     = P.CDPRODUTO   AND
                           R.CDETAPAPROD   = @C_INSUMOS_CDETAPAPROD
                        GROUP BY
                           I.CDFILIAL, I.NRRETEST, I.NRSEQRETPROD, I.CDPRODUTO, P.NMPRODUTO, R.CDCENTCUST

                  UNION

                  SELECT

                     (((ROUND(ITEMRETIEST.QTPRERETPROD, 5) / 1000) * PM.VRPRODAGUA) / ITEMRETIEST.QTPRERETPROD) AS VRCUSTO,
                     ROUND(ITEMRETIEST.QTPRERETPROD, 5) AS QTRETI,PRODUTO.NMPRODUTO,
                     RETIRADAESTO.CDCENTCUST
                    FROM
                       PRODUTO, RETIRADAESTO, ITEMRETIEST, PARAMAN PM
                   WHERE
                      RETIRADAESTO.CDFILIAL      = @P_CDFILIAL               AND
                      RETIRADAESTO.NRORDPROD     = @P_NRORDPROD              AND
                      RETIRADAESTO.NRSUBORDPROD  = @P_NRSUBORDPROD           AND
                      RETIRADAESTO.CDFILIAL      = ITEMRETIEST.CDFILIAL      AND
                      RETIRADAESTO.NRRETEST      = ITEMRETIEST.NRRETEST      AND
                      ITEMRETIEST.CDPRODUTO      = PRODUTO.CDPRODUTO         AND
                      ITEMRETIEST.CDPRODUTO      = @C_INSUMOS_CDPRODINSUMO   AND
                      RETIRADAESTO.CDFILIAL      = PM.CDFILIAL               AND
                      ITEMRETIEST.CDPRODUTO      = PM.CDPRODAGUA             AND
                      PM.IDPRODUTOUNICO          = 'S'                       AND
                      ITEMRETIEST.CDTIPORETI     NOT IN (SELECT CDTIPORETI
                                                          FROM TIPORETI
                                                         WHERE (CDFUNCUSTO = '099'))

                  UNION

                  SELECT

                     (((ROUND(ITEMRETIEST.QTPRERETPROD, 5) / 1000) * MP1.VRPRODAGUA) / ITEMRETIEST.QTPRERETPROD) AS VRCUSTO,
                     ROUND(ITEMRETIEST.QTPRERETPROD, 5) AS QTRETI,PRODUTO.NMPRODUTO,
                     RETIRADAESTO.CDCENTCUST
                    FROM
                       PRODUTO, RETIRADAESTO, ITEMRETIEST, PARAMAN PM, MULTPRODUTOS MP1
                   WHERE
                      RETIRADAESTO.CDFILIAL      = @P_CDFILIAL               AND
                      RETIRADAESTO.NRORDPROD     = @P_NRORDPROD              AND
                      RETIRADAESTO.NRSUBORDPROD  = @P_NRSUBORDPROD           AND
                      RETIRADAESTO.CDFILIAL      = ITEMRETIEST.CDFILIAL      AND
                      RETIRADAESTO.NRRETEST      = ITEMRETIEST.NRRETEST      AND
                      ITEMRETIEST.CDPRODUTO      = PRODUTO.CDPRODUTO         AND
                      ITEMRETIEST.CDPRODUTO      = @C_INSUMOS_CDPRODINSUMO   AND
                      RETIRADAESTO.CDFILIAL      = PM.CDFILIAL               AND
                      RETIRADAESTO.CDFILIAL      = MP1.CDFILIAL              AND
                      ITEMRETIEST.CDPRODUTO      IN (SELECT CDPRODUTO
                                                       FROM MULTPRODUTOS MP2
                                                      WHERE CDFILIAL = P_CDFILIAL
                                                        AND MP2.CDPRODUTO = MP1.CDPRODUTO
                                                        AND MP2.CDFILIAL = MP1.CDFILIAL) AND
                      PM.IDMULTPRODUTOS          = 'S'                       AND
                      ITEMRETIEST.CDTIPORETI     NOT IN (SELECT CDTIPORETI
                                                          FROM TIPORETI
                                                         WHERE (CDFUNCUSTO = '099'))

               )I;

               OPEN C_CUSTOETAPA;
               FETCH NEXT FROM C_CUSTOETAPA INTO @C_CUSTOETAPA_VRCUSTO, @C_CUSTOETAPA_QTDE_INSUMO, @C_CUSTOETAPA_NMPRODUTO, @C_CUSTOETAPA_CDCENTCUST;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_SEQUCUSTO = @V_SEQUCUSTO + 1;
                  INSERT INTO APRCUSTOP
                             (CDFILIAL,
                              NRORDPROD,
                              NRSUBORDPROD,
                              CDETAPAPROD,
                              CDPRODUTO,
                              NRAPRCUSTOP,
                              CDCUSTOINDI,
                              CDFUNCUSTO,
                              NRLOTEESTQ,
                              NRSUBLOTE,
                              CDAPRCUSTOP,
                              NMAPRCUSTOP,
                              QTAPRCUSTOP,
                              VRAPRCUSTOP,
                              CDCENTCUST)
                          VALUES
                             (@P_CDFILIAL,
                              @P_NRORDPROD,
                              @P_NRSUBORDPROD,
                              @C_INSUMOS_CDETAPAPROD,
                              @C_PRODACABADO_CDPRODUTO,  /* Produto de Produo */
                              RIGHT(REPLICATE('0',10) + @V_SEQUCUSTO, 10),
                              @V_CDCUSTOINDI,
                              '001',
                              @C_PRODACABADO_NRLOTEESTQ,
                              @C_PRODACABADO_NRSUBLOTE,
                              @C_INSUMOS_CDPRODINSUMO, /* Matria Prima / Insumos */
                              @C_CUSTOETAPA_NMPRODUTO,
                              ROUND(@C_CUSTOETAPA_QTDE_INSUMO,5),
                              ROUND(@C_CUSTOETAPA_VRCUSTO,5),
                              @C_CUSTOETAPA_CDCENTCUST);

                  FETCH NEXT FROM C_CUSTOETAPA INTO @C_CUSTOETAPA_VRCUSTO, @C_CUSTOETAPA_QTDE_INSUMO, @C_CUSTOETAPA_NMPRODUTO, @C_CUSTOETAPA_CDCENTCUST;
               END;
               CLOSE C_CUSTOETAPA;
               DEALLOCATE C_CUSTOETAPA;
               FETCH NEXT FROM C_INSUMOS INTO @C_INSUMOS_QTDEINSUMO,
                                              @C_INSUMOS_CDPRODUTO,
                                              @C_INSUMOS_CDPRODINSUMO,
                                              @C_INSUMOS_CDETAPAPROD;

            END;

            CLOSE C_INSUMOS;
            DEALLOCATE C_INSUMOS;
            FETCH NEXT FROM C_PRODACABADO INTO  @C_PRODACABADO_CDFILIAL,
                                             @C_PRODACABADO_QTAPRODPREOP,
                                             @C_PRODACABADO_CDPRODUTO,
                                             @C_PRODACABADO_CDPROCFABRIC,
                                             @C_PRODACABADO_NRLOTEESTQ,
                                             @C_PRODACABADO_NRSUBLOTE,
                                             @C_PRODACABADO_QTPRACABADO;
         END;
         CLOSE C_PRODACABADO;
         DEALLOCATE C_PRODACABADO;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CALCULA_CUSTO_OP_CONS','6.10.XXX';
GO
